void ip_get_epsmach(double *);
void ip_write_double(double *, int , int , char *);
void ip_write_int(int *, int , int , char *);
/* 
int  ip_comp_camp1(K_L_ARC *, K_L_ARC *);
int  ip_comp_camp2(K_L_ARC *, K_L_ARC *);
*/
int  ip_comp_camp1(const void *, const void *);
int  ip_comp_camp2(const void *, const void *);
double ip_norma2(double *, int);
double prod_esc(int, double *, double *);
void dcopia(int, double *, double *);
int  indmax(int, double *);
int  indmin(int, double *);
void ip_verifica_problema();
void ip_preproces_cmt();
void ip_tracta_cb();
void ip_get_ufcb();
void ip_allocatar_memoria_ini();
void ip_write_iexit();
void ip_ajusta_valors();
void ip_free_memoria();
void ip_get_nat_pointers();
void ip_get_epsmach(double *);
void ip_get_ipk_ipl();
void ip_get_pfa_ipfa();
void ip_simbolic_ASAt();
void ip_arreglar_numeracio_pfa_ipfa();
void ip_permuta_nusos();
void ip_get_ilnz();
void ip_restaura_dades();
void ip_despermuta_nusos();
void ip_restaura_cb();
void ip_get_cb_estruct();
void ip_write_dimensions();
void ip_write_info();
void ip_allocatar_memoria_opt();
void ip_inicialitza_opt();
char ip_optimality();
void ip_get_Ax(double *, double *, double *, double *, double *, 
	       double *);
void ip_get_Aty(double *, double *, double *, double *, 
		double *, double *);
void ip_desactivar_cmt();
void ip_get_f();
void ip_get_mu();
void ip_get_S();
void ip_get_direccio();
void ip_get_alfa();
void ip_update_newpoint();
void ip_test_newpoint();
void ip_get_Sr();
void ip_get_dy(int *);
void ip_get_ASkAt(int *);
void ip_solve_ASkAt(double *);
void ip_Ct_v(double *, double *);
void ip_C_v(double *, double *);
void ip_comprovar_direccio_es_correcta();
void ip_get_D();
int ip_MCG_x(int, double *, double *);
int ip_H_x(int, double *, double *, int (*atimes) (int, double *, double *));
int ip_jacobi_x(int, double *, double *, double *, double);
int dcg(int, int (atimes) (int, double *, double *), 
	int (msolve) (int, double *, double *, int (*atimes)()),
	double *, double *, double *, double *, double *, int, double, 
	double *);
int  idamax(int, double *, int);
void daxpy(int, double, double *, int, double *, int);
void daxpyx(int, double , double *, int, double *, int);
void dcopy(int, double *, int, double *, int);
double ddot(int, double *, int, double *, int);
double dnrm2(int, double *, int);
void dexopy(int, double *, double *, double *, int);
void dfill(int, double *, double);
double r2mach();

#ifdef SGI
#define ORDMMD ordmmd_
#define SFINIT sfinit_
#define SYMFCT symfct_
#define BFINIT bfinit_
#define BLKFCT blkfct_
#define MMPY4  mmpy4_
#define SMXPY4 smxpy4_
#define BLKSLV blkslv_
#endif
#ifdef LINUX
#define ORDMMD ordmmd_
#define SFINIT sfinit_
#define SYMFCT symfct_
#define BFINIT bfinit_
#define BLKFCT blkfct_
#define MMPY4  mmpy4_
#define SMXPY4 smxpy4_
#define BLKSLV blkslv_
#endif
#ifdef ALPHA
#define ORDMMD ordmmd_
#define SFINIT sfinit_
#define SYMFCT symfct_
#define BFINIT bfinit_
#define BLKFCT blkfct_
#define MMPY4  mmpy4_
#define SMXPY4 smxpy4_
#define BLKSLV blkslv_
#endif
#ifdef SUN
#define ORDMMD ordmmd_
#define SFINIT sfinit_
#define SYMFCT symfct_
#define BFINIT bfinit_
#define BLKFCT blkfct_
#define MMPY4  mmpy4_
#define SMXPY4 smxpy4_
#define BLKSLV blkslv_
#endif
#ifdef HP
#define ORDMMD ordmmd
#define SFINIT sfinit
#define SYMFCT symfct
#define BFINIT bfinit
#define BLKFCT blkfct
#define MMPY4  mmpy4
#define SMXPY4 smxpy4
#define BLKSLV blkslv
#endif

void ORDMMD(int *nnux, int *xadj, int *ajcncy2, int *ipfa, int *pfa,
	    int *iwsiz,int *iwork, int *nofsub, int *iflag);
void SFINIT(int *nnux, int * nnza, int *xadj, int *ajcncy2, int *pfa,
	    int *ipfa, int *colcnt, int *nnzl, int *nsub, int *nsuper,
	    int *snode, int *xsuper, int *iwsiz, int *iwork, int *iflag);
void SYMFCT(int *nnux, int *maxajc, int *xadj, int *ajcncy, int *pfa,
	    int *ipfa, int *colcnt, int *maxsuper, int *xsuper,
	    int *snode, int *maxsub, int *xlindx, int *lindx, 
	    int *xlnz, int *iwsiz, int *workspak, int *iflag);
void BFINIT(int *nnux, int *maxsuper, int *xsuper, int *snode, 
	    int *xlindx, int *lindx, int *i, int *tmpsiz, int *split);
void BLKFCT(int *nnux, int *maxsuper, int *xsuper, int *snode, int *split,
	    int *xlindx, int *lindx, int *xlnz, double *lnzk, int *iwsiz,
	    int *workspak, int *tmpsiz, double *tmpvec, int *iret,
	    void(mmpy4) (int *m, int *n, int *q, int *xpnt, double *x, 
			 double *y, int *ldy), 
	     void (smxpy4)(int *m, int *n, double *y, int *apnt, double *a));
void MMPY4(int *m, int *n, int *q, int *xpnt, double *x, double *y, int *ldy);
void SMXPY4(int *m, int *n, double *y, int *apnt, double *a);
void BLKSLV(int *maxsuper, int *xsuper, int *xlindx, int *lindx, 
	     int *xlnz, double *lnzk, double *vk);
